#uses "unCoreLHCServices"
#uses "unGenericFunctions_core"
#uses "fwGeneral/fwGeneral"

/**@file

// unCMWServerDeprecated.ctl
This library contains all the deprecated functions from unCMWServer.

@par Creation Date
  26/06/2018

@author
  Marcin Bes (BE-ICS-FD)
*/

/**
* @deprecated 2018-06-26

  @param Select Content of Select column in table
  @param Device Content of Device column in table
  @param Alias Content of Alias column in table
  @param Dpe Content of Dpe column in table
  @param Property Content of Property column in table
  @param Direction Content of Direction column in table
  @param Value Content of Value column in table
  @param Time Content of Time column in table
  @param exceptionInfo_Temp Variable for error messages
*/
unCMWServer_classByDevice(dyn_string &Select, dyn_string &Device,  dyn_string &Alias, dyn_string &Dpe, 
							dyn_string &Property, dyn_string &Direction, dyn_string &Value, dyn_string &Time, dyn_string &exceptionInfo_Temp)
{
FWDEPRECATED();
dyn_string dsUniqueDevice;

dsUniqueDevice = Device;
dynUnique(dsUniqueDevice);
}

// unCMWServer_getFromFile
/**
Purpose: Check Line syntax for Config File

  @param sConfigPath string, input, Path
  @param Select dyn_string, output, array for the Selected column 
  @param Device dyn_string, output, array for the Archive column  
  @param Alias dyn_string, output, array for the Alias column 
  @param Dpe dyn_string, output, array for the Dpe column 
  @param Property dyn_string, output, array for the Name column
  @param Direction dyn_string, output, array for the Description column
  @param Value dyn_string, output, array for the Range column
  @param Time dyn_string, output, array for the State column
  @param Line dyn_string, output, array for the FF column
  @param bEr dyn_string, output, array for the FM column
			
						
Usage: Public

PVSS manager usage: UI (WCCOANV) and UI extended (WCCOANG)

Constraints:
	. PVSS version: 3.0 
	. operating system: W2000, NT, XP and Linux, but tested only under XP and Linux.
	. distributed system: yes.

  @deprecated 2018-12-14
*/
unCMWServer_getFromFile(string sConfigPath, dyn_string &Select, dyn_string &Device,  dyn_string &Alias, dyn_string &Dpe, 
							dyn_string &Property, dyn_string &Direction, dyn_string &Value, dyn_string &Time, dyn_int &Line, bool &bEr)
{
FWDEPRECATED();

string fileInString, sSelect, sDevice, sAlias, sDpe, sProperty, sDirection, sValue, sTime, sPath;
int i, len, iLen_Range,imaxRange,j,len2,iNbLine,iStart ;
float fMax, fIndex;
dyn_string dsFileLines, dsSplitRange;
dyn_dyn_string ddsFile;
bool bChange, bDefined;

	iNbLine=0;
	if (isFunctionDefined("ctrlConfRead"))
	{
		ctrlConfRead(sConfigPath,ddsFile);
		len=dynlen(ddsFile);
		fMax=len;
		
		for (i=1;i<=len;i++) //read each statement
		{				
			int l=1;
			dsFileLines=ddsFile[i];
			len2=dynlen(dsFileLines);
			fIndex=i;
			progressBar.progress(fIndex/fMax*100);
			if(patternMatch("*[*]*", dsFileLines[l]))
			{
				bDefined=true;
//				sDevice=dsFileLines[l];
				sDevice=substr(dsFileLines[l],1,strlen(dsFileLines[l])-2);
				iNbLine++;
			} //End pattern type
			else //dpe
			{
				if(bDefined)
				{
					l++;
					if(patternMatch("*dpe=*", dsFileLines[l]))
					{
						sDpe=substr(dsFileLines[l], strpos(dsFileLines[l],"=")+1,strlen(dsFileLines[l]));
						l++;
						iNbLine++;
						if(patternMatch("*alias=*", dsFileLines[l]))
						{
							sAlias=substr(dsFileLines[l], strpos(dsFileLines[l],"=")+1,strlen(dsFileLines[l]));
							l++;			
							iNbLine++;
							if(patternMatch("*property=*", dsFileLines[l]))
							{
								sProperty=substr(dsFileLines[l], strpos(dsFileLines[l],"=")+1,strlen(dsFileLines[l]));
								l++;						
								iNbLine++;
								sSelect="X";
								if(patternMatch("*direction=*", dsFileLines[l]))
								{
									sDirection=substr(dsFileLines[l], strpos(dsFileLines[l],"=")+1,strlen(dsFileLines[l]));
									l++;	
									iNbLine++;	
								} //End pattern direction	
								else
								{
									sSelect="F";
									bEr=true;	
									sDirection="ERROR";
								}	
								if(patternMatch("*value=*", dsFileLines[l]))
								{
									sValue=substr(dsFileLines[l], strpos(dsFileLines[l],"=")+1,strlen(dsFileLines[l]));
									l++;	
									iNbLine++;	
								}	//End pattern value
								else
								{
									sSelect="F";
									bEr=true;	
									sValue="ERROR";
								}	
								if(patternMatch("*time=*", dsFileLines[l]))
								{
									sTime=substr(dsFileLines[l], strpos(dsFileLines[l],"=")+1,strlen(dsFileLines[l]));
									l++;	
									iNbLine++;	
								}//End pattern time
								else
								{
								 	sSelect="F";
								 	bEr=true;	
								 	sTime="ERROR";
								}
							} //End pattern property
							else
							{
								sSelect="F";
								sProperty="ERROR";
								sDirection="ERROR";
								sValue="ERROR";
								sTime="ERROR";
								bEr=true;
							}			
						} //End pattern alias
						else
						{
							sSelect="F";
							sAlias="ERROR";
							sProperty="ERROR";
							sDirection="ERROR";
							sValue="ERROR";
							sTime="ERROR";
							bEr=true;
						}
				
					}// End pattern dpe
					else //dpe ERROR
					{
						sSelect="F";
						sDpe="ERROR";
						sAlias="ERROR";
						sProperty="ERROR";
						sDirection="ERROR";
						sValue="ERROR";
						sTime="ERROR";
						bEr=true;	
					}
						dynAppend(Select,sSelect);
						dynAppend(Device,sDevice);
						dynAppend(Alias,sAlias);
						dynAppend(Dpe,sDpe);
						dynAppend(Property,sProperty);
						dynAppend(Direction,sDirection);
						dynAppend(Value,sValue);
						dynAppend(Time,sTime);
						dynAppend(Line,iNbLine);	
				}
				else //first element error
				{
					dynAppend(Select,"F");
					dynAppend(Device,"ERROR");
					dynAppend(Alias,"ERROR");
					dynAppend(Dpe,"ERROR");
					dynAppend(Line,iNbLine);		
					dynAppend(Property,"ERROR");
					dynAppend(Direction,"ERROR");
					dynAppend(Value,"ERROR");
					dynAppend(Time,"ERROR");
					bEr=true;
				}
			} //End else pattern type
		} //End for
	}//End if function defined
	else
	{
	DebugN("DLL not defined");
	bEr=true;
	}//End function not defined

}

// unCMWServer_CheckLine
/**
Purpose: Check Line syntax for Config File

  @param sDevice string, input, Device name
  @param sAlias bool, input, true -> PVSS alarm; false -> No PVSS alarm
  @param sDpe string, input, string for the Dpe cell
  @param sProperty string, input, string for the Name
  @param sDirection string, input, string for the State
  @param sValue string, input, string for the Fault Code 
  @param sTime string, input, string for the Description
  @param sEr string, output, Pattern for the error 
						
Usage: Public

PVSS manager usage: UI (WCCOANV) and UI extended (WCCOANG)

Constraints:
	. PVSS version: 3.0 
	. operating system: W2000, NT, XP and Linux, but tested only under XP and Linux.
	. distributed system: yes.

  @deprecated 2018-12-14
*/
unCMWServer_CheckLine(string sDevice, string sAlias, string sDpe, string sProperty, string sDirection, 
string sValue, string sTime, string &sEr)
{
FWDEPRECATED();

int iEr, iFC, iEr_2;
string sFC_Temp;
dyn_string dsSplitHierarchy;
bool bValid;

	sEr="";
	if ((sDpe!="") && (sAlias=="")){
		//Case 1 : dpe="something" alias =
				if (!dpExists(sDpe)) sEr="Dpe";	
			}
		else 
			if ((sDpe!="") && (sAlias!="")){
		//Case 2 : dpe="ProcessInput.Post" alias ="Alias"
				sDpe = unGenericDpFunctions_dpAliasToName(sAlias)+sDpe;
				if (!dpExists(sDpe)) sEr="Dpe";	
			}
		
	//. Device	
	iEr=0;
	iEr=strpos(sDevice,"\"");
	iEr=strpos(sDevice,"'") + iEr;
	iEr=strpos(sDevice,">") + iEr;
	iEr=strpos(sDevice,"<") + iEr;
	iEr=strpos(sDevice,"~") + iEr; 
	if (iEr> -5 || sDevice =="ERROR")		
		{
		sEr="Device";
		return;
		}
	
	//. Property
	iEr=0;
	iEr=strpos(sProperty,"'") + iEr;
	iEr=strpos(sProperty,">") + iEr;
	iEr=strpos(sProperty,"<") + iEr;
	iEr=strpos(sProperty,"~") + iEr; 
	if (iEr> -4 || sProperty =="ERROR")	
	if (sProperty=="ERROR")		
		{
		sEr="Property";
		return;
		}
	
	//. Direction
	if ((sDirection!="in") && (sDirection!="out") && (sDirection!="in/out") )
		bValid=false;
	else bValid=true;	
	if ((!bValid) || (sDirection=="ERROR"))		
		{
		sEr="Direction";
		return;
		}
	
	//. Value
	if ((sValue!="boolean") && (sValue!="byte") && (sValue!="short") && (sValue!="long") && (sValue!="longlong")
	&& (sValue!="float") && (sValue!="double")&& (sValue!="string"))
		bValid=false;
	else bValid=true;	
	
	if ((!bValid) || (sValue=="ERROR"))		
	{
		sEr="Value";
		return;
	}
	
	//. Time
	if ((sTime!="longlongnano") && (sTime!="longlong")	&& (sTime!="double"))		bValid=false;
	else bValid=true;	
	
	if ((!bValid) || (sTime=="ERROR"))		
		{
		sEr="Time";
		return;
		}
}

// unCMWServer_Check
/**
Purpose: Check Line syntax for Config File

  @param stable string, input, string for the Dpe cell
  @param bPanelCheck string, input, string for the Name
  @param iRow string, input, string for the State
  @param sMess_Error string, input, string for the Range
  @param bError string, input, string for the Fault Family 
  @param Select string, input, string for the Fault Member 
  @param Device string, input, string for the Fault Code 
  @param Alias string, input, string for the Description
  @param Dpe string, output, Pattern for the error 
  @param Property bool, input, true=Error
  @param Direction string, input, Table name to update
  @param Value bool, input, true=Need to add line before setColor
  @param Time int, input, Line Number in Table
						
Usage: Public

PVSS manager usage: UI (WCCOANV) and UI extended (WCCOANG)

Constraints:
	. PVSS version: 3.0 
	. operating system: W2000, NT, XP and Linux, but tested only under XP and Linux.
	. distributed system: yes.

  @deprecated 2018-12-14
*/
unCMWServer_Check(string stable, bool bPanelCheck, int iRow, string &sMess_Error, bool &bError, string Select, string Device, string Alias,string Dpe, string Property, string Direction, string Value, string Time)
{
FWDEPRECATED();

string sError;
int iLine;

	if (Select!="S")
	{
		unCMWServer_CheckLine(Device, Alias, Dpe, Property, Direction, Value, Time, sError);

		if (sError!="")
		{
		// In case of just checking (unLaserConfigFile_check.pnl) -> need to add line in Table
			if (bPanelCheck)
			{
				setValue(stable,"appendLine",
						"Select", Select,
						"Device", Device, 
						"Alias", Alias,
						"Dpe", Dpe, 
						"Property", Property, 
						"Direction", Direction, 
						"Value", Value, 
						"Time", Time);
				getValue(stable,"lineCount",iLine);
				iLine=iLine-1;
			}											
			else iLine=iRow;
			bError=true;
		
		switch(sError)
			{
			case "Device":						
				setMultiValue(stable, "cellBackColRC", iLine, "Device", "unCMWServer_Bad");				
				sMess_Error= sMess_Error + "\n\t-> " + Alias + Dpe + "\n";
				sMess_Error= sMess_Error + "\t" + getCatStr(g_sCat_CMWServer,"LOGCHECKDEVICE") + "\n";
				if (!bPanelCheck)
				{
					getValue(stable, "cellValueRC", iRow + 1, "Device", Device);
					if (Device=="")
						{
						setMultiValue(	stable, "cellBackColRC", iLine, "Device", "unCMWServer_Bad");	
						}
				}
				
			case "Alias":						
				setMultiValue(	stable, "cellBackColRC", iLine, "Alias", "unCMWServer_Bad");				
				sMess_Error= sMess_Error + "\n\t-> " + Alias + Dpe + "\n";
				sMess_Error= sMess_Error + "\t" + getCatStr(g_sCat_CMWServer,"LOGCHECKALIAS") + "\n";
			break;
			
			case "Dpe":						
				setMultiValue(	stable, "cellBackColRC", iLine, "Dpe", "unCMWServer_Bad");				
				sMess_Error= sMess_Error + "\n\t-> " + Alias + Dpe  + "\n";
				sMess_Error= sMess_Error + "\t" + getCatStr(g_sCat_CMWServer,"LOGCHECKDPE") + "\n";
				if (!bPanelCheck)
				{
					getValue(stable, "cellValueRC", iRow + 1, "Dpe", Dpe);
					if (Dpe=="")
						{
						setMultiValue(	stable, "cellBackColRC", iLine, "Dpe", "unCMWServer_Bad");	
						}
				}
			break;

			case "Property":			
				setMultiValue (stable, "cellBackColRC", iLine,"Name", "unCMWServer_Bad");
				sMess_Error= sMess_Error + "\n\t-> " + Alias + Dpe + "\n";
				sMess_Error= sMess_Error + "\t" + getCatStr(g_sCat_CMWServer,"LOGCHECKPROPERTY") + Name + "\n";
			break;
			
			case "Direction":
				setMultiValue (stable, "cellBackColRC", iLine, "Direction", "unCMWServer_Bad");
				sMess_Error= sMess_Error + "\n\t-> " + Alias + Dpe + "\n";
				sMess_Error= sMess_Error + "\t" + getCatStr(g_sCat_CMWServer,"LOGCHECKDIRECTION") + Direction + "\n";
			break;
			
			case "Value":
				setMultiValue (stable, "cellBackColRC", iLine, "Value", "unCMWServer_Bad");
				sMess_Error= sMess_Error + "\n\t-> " + Alias + Dpe + "\n";
				sMess_Error= sMess_Error + "\t" + getCatStr(g_sCat_CMWServer,"LOGCHECKVALUE") + Value + "\n";
			break;
			
			case "Time":
				setMultiValue (stable, "cellBackColRC", iLine, "Time", "unCMWServer_Bad");
				sMess_Error= sMess_Error + "\n\t-> " + Alias + Dpe + "\n";
				sMess_Error= sMess_Error + "\t" + getCatStr(g_sCat_CMWServer,"LOGCHECKTIME") + Time + "\n";
			break;
			
			default:
				setMultiValue(	stable, "cellBackColRC", iLine, "Select", "unCMWServer_Bad", 
								stable, "cellBackColRC", iLine, "Device", "unCMWServer_Bad",
								stable, "cellBackColRC", iLine, "Alias", "unCMWServer_Bad", 
								stable, "cellBackColRC", iLine, "Dpe", "unCMWServer_Bad", 
								stable, "cellBackColRC", iLine,"Property", "unCMWServer_Bad", 
								stable, "cellBackColRC", iLine, "Direction", "unCMWServer_Bad", 
								stable, "cellBackColRC", iLine, "Value", "unCMWServer_Bad", 
								stable, "cellBackColRC", iLine, "Time", "unCMWServer_Bad",
								stable, "cellValueRC", iLine, "Select", "F");
			}
		}
		else
		{
			if ((Select=="Q")&&(Dpe!="")&&(Alias==""))
			{
				if (bPanelCheck)
				{
					setValue(stable,"appendLine",
							"Select", Select,
							"Device", Device, 
							"Alias", Alias, 
							"Dpe", Dpe, 
							"Property", Property, 
							"Direction", Direction, 
							"Value", Value, 
							"Time", Time);
				
					getValue(stable,"lineCount",iLine);
					iLine=iLine-1;
					setMultiValue(stable, "cellBackColRC", iLine, "Dpe", "unCMWServer_NotDefined");
				}											
				bError=true;
				sMess_Error= sMess_Error + "\n\t-> " + Alias + Dpe + "\n";
				sMess_Error= sMess_Error + "\t" + getCatStr(g_sCat_CMWServer,"LOGCHECKNOTDEFINED") + "\n";
			}
		}					
	}


}


// unCMWServer_getStatus
/**
Purpose: get state of CMWServer system

  @param iIndex int, input, Position in Array  
  @param iState int, output, State of Manager or Archive  
						
Usage: Public

PVSS manager usage: Ctrl, UI (WCCOANV) and UI extended (WCCOANG)

Constraints:
	. PVSS version: 3.15
	. operating system: Linux, Windows.
	. distributed system: yes.

  @deprecated 2018-12-31
*/

void unCMWServer_getStatus(int iIndex, int &iState)
{
FWDEPRECATED();

  int iManagerState = 0, iManagerMessage = 0;
  iState = c_Ok;

  if((iIndex > 0) && (iIndex <= dynlen(g_diCMWServer_PVSS)) && (iIndex <= dynlen(g_diCMWServer_Message)))
  {
    //PVSS: manager state
    if(g_diCMWServer_PVSS[iIndex] != 1) // Manager is stopped
    {
      iManagerState = 1;
    }
    //Message
    if(g_diCMWServer_Message[iIndex] > 10001)  // 1000 is OK, all numbers above are not
    {
      iManagerMessage = g_diCMWServer_Message[iIndex];
    }

    // Final decision
    if((dynContains(g_diCMWServerCritical_Alarm, iManagerMessage) > 0) || (iManagerState == 1))	//Error(s)
    {
      iState = c_Error;
    }
    else if(iManagerMessage > 0)
    {
      iState = c_Warning;
    }
  }
}


// unCMWServer_setStatusTable
/**
Purpose: set state of CMWServer system

  @param sName string, input, Name of Manager
  @param iIndex int, input, index for Global Variable 
  @param iState int, input, Status
  @param tStateTime time, input, Time of Status change
						
Usage: Public

PVSS manager usage: Ctrl, UI (WCCOANV) and UI extended (WCCOANG)

Constraints:
	. PVSS version: 3.0 
	. operating system: W2000, NT, XP and Linux, but tested only under XP and Linux.
	. distributed system: yes.

  @deprecated 2018-12-31
*/

unCMWServer_setStatusTable(string sName, int iIndex, int iState, time tStateTime)
{
FWDEPRECATED();

  string sTable = "ManagersList";      // The name of Table control in panel - hardcoded
	
  for(int iRow = 0 ; iRow < ManagersList.lineCount() ; iRow++)
  {
    string sCellContent;
    getValue(sTable, "cellValueRC", iRow, "Names", sCellContent);
    if(sCellContent == sName)  // Row for manager found in Table
    {
      string sText_PVSS;
      unCoreLHCServices_PVSS(g_diCMWServer_PVSS[iIndex], sText_PVSS);
      string sText_Command = getCatStr(g_sCat_CMWServer, g_diCMWServer_Command[iIndex]),
             sText_StateOut = getCatStr(g_sCat_CMWServer, g_diCMWServer_State[iIndex]),
             sText_Message = getCatStr(g_sCat_CMWServer, g_diCMWServer_Message[iIndex]),
             sColor;
      switch(iState)
      {
      case c_Ok:
        sColor = "unCMWServer_Ok";
        break;
      case c_Warning:
        sColor = "unCMWServer_Warning";
        break;
      case c_Error:
        /* NOBREAK */
      default:
        sColor = "unCMWServer_Bad";
      }
      string sTimeString;
      if(year(tStateTime) > 1970)  // Time is not empty
      {
        sTimeString = formatTime("%c", tStateTime);
      }
      setMultiValue(sTable, "cellBackColRC", iRow, "X", sColor,
                    sTable, "cellValueRC", iRow, "PVSS", sText_PVSS,
                    sTable, "cellValueRC", iRow, "Command", sText_Command,
                    sTable, "cellValueRC", iRow, "StateOut", sText_StateOut,
                    sTable, "cellValueRC", iRow, "MessageOut", sText_Message,
                    sTable, "cellValueRC", iRow, "Time", sTimeString);
      break;
    }
  }
}


// unCMWServer_getPosition
/**
Purpose: get index for Manager (need for Global dyn)

  @param sName string, input, Archive's name or Manager's name
  @param iIndex int, output, position in Array of this name
						
Usage: Public

PVSS manager usage: UI (WCCOANV) and UI extended (WCCOANG)

Constraints:
	. PVSS version: 3.0 
	. operating system: W2000, NT, XP and Linux, but tested only under XP and Linux.
	. distributed system: yes.

  @deprecated 2018-12-31
*/

unCMWServer_getPosition(string sName, int &iIndex)
{
FWDEPRECATED();
  iIndex = dynContains(g_dsCMWServer_Name, sName);
}

// unCMWServer_Update_PVSS_Status
/**
Purpose: Apply new calculated PVSS manager status (Started/Stopped/Blocked):
         save to global list and either display the state in table on panel,
         or write the value to ev_MessageOut DPE

  @param sManager string, input, Manager Name
  @param iState_PVSS dyn_string, States of Manager in PVSS console
						
Usage: Public

PVSS manager usage: UI (WCCOANV) and UI extended (WCCOANG)

Constraints:
	. PVSS version: 3.0 
	. operating system: W2000, NT, XP and Linux, but tested only under XP and Linux.
	. distributed system: yes.

  @deprecated 2018-12-31
*/

unCMWServer_Update_PVSS_Status(string sManager, int iState_PVSS)
{
FWDEPRECATED();
  int iPosition;  // Index of this manager in global lists
  unCMWServer_getPosition(sManager, iPosition);
  if(iState_PVSS != g_diCMWServer_PVSS[iPosition])  //PVSS Status has changed
  {
    g_diCMWServer_PVSS[iPosition] = iState_PVSS;

    if (myManType()==UI_MAN) //IS-1745
    {
      //2.2 Get State
      int iOverallStatus;
      unCMWServer_getStatus(iPosition, iOverallStatus);

      //2.3 Update Table in Panel
      unCMWServer_setStatusTable(sManager, iPosition, iOverallStatus, "");
    }
    else
    {
      dpSet(getSystemName() + sManager + ".State.c", g_diCMWServer_Message[iPosition]);
    }
  }
}

// unCMWServer_Integrity
/**
Purpose:
  The function runs in separate thread (never stops) and periodically checks if heartbeats
  fom given CMWServer manager are arriving at right periods.
  
  @param sManager string, input, Manager Name
  @param sSystem
						
Usage: Public

PVSS manager usage: UI (WCCOANV) and UI extended (WCCOANG)

Constraints:
	. PVSS version: 3.0 
	. operating system: W2000, NT, XP and Linux, but tested only under XP and Linux.
	. distributed system: yes.


  @deprecated 2018-12-31
*/

// @reviewed 2018-06-26 @whitelisted{Thread}

unCMWServer_Integrity(string sManager, string sSystem)
{
FWDEPRECATED();
  int iPosition;
  unCMWServer_getPosition(sManager, iPosition);

  // If CMWServer was never started - the value of DPE .Settings.man_NumPeriod may be uninitialized
  if(g_diCMWServer_Period[iPosition] <= 0)
  {
    g_diCMWServer_Period[iPosition] = c_Min_Rate;
  }
  
  while(true)  // Infinite loop
  {
    unCMWServer_Check_Integrity(sManager, sSystem);
    unCMWServer_getPosition(sManager, iPosition);
    if(iPosition < 1)  // Manager removed from list
    {
      delay(c_Min_Rate);
    }
    else
    {
      delay(g_diCMWServer_Period[iPosition]);
    }
  }
}

// unCMWServer_Check_Integrity
/**
Purpose: Function checks period of answer from Manager, manager must periodically update
          the value (_stime) of .Settings.man_Num DPE

  @param sMan string, input, Manager Name
  @param sSystem
						
Usage: Public

PVSS manager usage: UI (WCCOANV) and UI extended (WCCOANG)

Constraints:
	. PVSS version: 3.0 
	. operating system: W2000, NT, XP and Linux, but tested only under XP and Linux.
	. distributed system: yes.

  @deprecated 2018-12-31
*/

unCMWServer_Check_Integrity(string sMan, string sSystem)
{
FWDEPRECATED();
  dyn_string exceptionInfo;
  int iManNum = unCMWServer_decodeManNum(sMan, exceptionInfo),
      iResultState = -1,  // Unknown/error state
      iPosition;  // Index of this manager in global lists
  unCMWServer_getPosition(sMan, iPosition);

  if(dynlen(exceptionInfo) == 0)
  {
    if(dynContains(g_diCMWServer_Api, iManNum))  // API manager with this number is running
    {
      time tHeartBeat;
      dpGet(sSystem + sMan + ".Settings.man_Num:_online.._stime", tHeartBeat);
      dyn_errClass err = getLastError();
      if(dynlen(err) == 0)
      {
        time tNow = getCurrentTime();
        float fIntervalSinceHeartBeat = tNow - tHeartBeat;
        if(fIntervalSinceHeartBeat > g_diCMWServer_Period[iPosition])
        {
          iResultState = 2;  //blocked: manager is running, no heartbeat
        }
        else
        {
          iResultState = 1;  //Started: manager is running, heartbeat is arrived as expected
        }
      }
    }
    else
    {
      iResultState = 0;  // Manager is STOPPED
    }
  }
  unCMWServer_Update_PVSS_Status(sMan, iResultState);	
}

//------------------------------------------------------------------------------------------------------------------------

// unSystemIntegrity__CMWServer_CB
/**
Purpose:
Callback for .Settings.man_NumPeriod DPE of CMWServer configuration DP, the DPE contains
heartbeat period for CMWServer, i.e. period the CMWSErver must refresh the value of .Settings.man_Num DPE

	@param sDp_1 string, input, data point name
	@param iPeriodMilli int, Period in minutes where CMWServer updates man_Num

Usage: Internal

PVSS manager usage: CTRL (WCCOACTRL)

Constraints:
	. PVSS version: 3.0 
	. operating system: W2000, NT, XP and Linux, but tested only under XP and Linux.
	. distributed system: yes.

  @deprecated 2018-12-31
*/

unSystemIntegrity__CMWServer_CB(string sDp_1, int iPeriodMilli)
{
FWDEPRECATED();
  string sManager = dpSubStr(sDp_1, DPSUB_DP);
  int iPosition;
  unCMWServer_getPosition(sManager, iPosition);
  int iPeriod = iPeriodMilli/1000;
  // Note the code below adds the value to g_diCMWServer_Period at proper position if it was not there before
  if(iPeriod < (c_Min_Rate/2))
  {
    g_diCMWServer_Period[iPosition] = c_Min_Rate;
  }
  else
  {
    g_diCMWServer_Period[iPosition] = iPeriod * 2;
  }
}

//------------------------------------------------------------------------------------------------------------------------

// unSystemIntegrity__CMWServer_CB_Api
/**
Purpose:
Callback for _Connections.Api.ManNums DPE: get list of all connected API managers in
the system. including CMWServer managers

	@param sDp_1: string, input, data point name
	@param diApi: dyn_int, Api Connections
Usage: Internal

PVSS manager usage: CTRL (WCCOACTRL)

Constraints:
	. PVSS version: 3.0 
	. operating system: W2000, NT, XP and Linux, but tested only under XP and Linux.
	. distributed system: yes.

  @deprecated 2018-12-31
*/

unSystemIntegrity__CMWServer_CB_Api(string sDp_1, dyn_int diApi)
{
FWDEPRECATED();
  g_diCMWServer_Api = diApi;
  string sSystem = dpSubStr(sDp_1, DPSUB_SYS);
  for(int idx = 1 ; idx <= dynlen(g_dsCMWServer_Name) ; idx++)
  {
    unCMWServer_Check_Integrity(g_dsCMWServer_Name[idx], sSystem);
  }
}

